""" Converts txt files of fish so that fish detections are 192, and not 0, to align with class labels of pre trained model
"""
import glob, os
import xml.etree.ElementTree as ET
import argparse
import shutil


parser = argparse.ArgumentParser()
parser.add_argument("in_directory")
parser.add_argument("out_directory")
parser.add_argument("in_directory_img")
parser.add_argument("out_directory_img")

def main(args):
    # Keep track of unique object types to convert to numerical id later
    files_written = 0
    images_copied = 0
    if not os.path.exists(args.out_directory):
        os.makedirs(args.out_directory)
    else: #this means there are files already there, so we want to remove them
        print(f"removing {len(os.listdir(args.out_directory))} files from {args.out_directory} since it exists")
        for files_ in os.listdir(args.out_directory):
                file_full_path = os.path.join(args.out_directory, files_)
                os.remove(file_full_path)

    # Find all txt files in current folder
    txt_fpaths = glob.glob("*.txt", root_dir=args.in_directory)
    print(f"Found {len(txt_fpaths)} txt files to copy")
    for file in txt_fpaths:
        filename_in = os.path.join(args.in_directory, file)
        with open(filename_in, 'r') as file_in:
            with open(os.path.join(args.out_directory,(file)),"w") as file_out:
                for line in file_in:
                    #replace first chaarcter with 192 when it is a 0
                    line = "192" + line[1:]
                    file_out.write(line)
                files_written += 1
    
    if not os.path.exists(args.out_directory_img):
        os.makedirs(args.out_directory_img)
    else: #this means there are files already there, so we want to remove them
        print(f"removing {len(os.listdir(args.out_directory_img))} files from {args.out_directory_img} since it exists")
        for files_ in os.listdir(args.out_directory_img):
                file_full_path = os.path.join(args.out_directory_img, files_)
                os.remove(file_full_path)
    # Find all image files in current folder
    image_fpaths = glob.glob("*.png", root_dir=args.in_directory_img)
    print(f"Found {len(image_fpaths)} image files to copy")
    for file in image_fpaths:
        filename_in = os.path.join(args.in_directory_img, file)
        #command to copy from current place to new place
        filename_out = os.path.join(args.out_directory_img, file)
        shutil.copyfile(filename_in, filename_out)
        images_copied += 1
        
    print(f"Wrote {files_written} txt files with the new number for fish detections.")
    print(f"Copied {images_copied} image files to new folder.")
    


if __name__ == "__main__":
    args = parser.parse_args()
    main(args)
