from ultralytics import YOLO

#load a model
#that was trained on OpenImagesv7, downloaded from https://docs.ultralytics.com/datasets/detect/open-images-v7/
model = YOLO("yolov8l-pretrained-oiv7.pt")


#select some photos from the validtion result where there is a fish, then we can run inference on those images
# Run batched inference on a list of images to see if pre-trained model picks up fish
# NEW USERS: you will have to customize the file paths in relation to where this python file is saved
results = model(["../scripts/data/val_for_pretrained/voith/val/images/Voith_20140625_104243_F04F_00408CCA70D1_870-900_fm_3.png",
                "../scripts/data/val_for_pretrained/voith/val/images/Voith_20140625_104243_F04F_00408CCA70D1_870-900_fm_175.png",
                "../scripts/data/train_files/Voith/images/Voith_20140625_104243_F04F_00408CCA70D1_60-90_fm_100.png",
                "../scripts/data/train_files/Voith/images/Voith_20140625_104243_F04F_00408CCA70D1_0-30_fm_49.png",
                "../scripts/data/train_files/Voith/images/Voith_20140625_104243_F04F_00408CCA70D1_0-30_fm_70.png",
                "../scripts/data/train_files/Voith/images/Voith_20140625_104243_F04F_00408CCA70D1_0-30_fm_59.png"], conf = 0.10, iou= 0.6)  # return a list of Results objects


i = 0
# Process results list
for result in results:
    boxes = result.boxes  # Boxes object for bounding box outputs
    masks = result.masks  # Masks object for segmentation masks outputs
    keypoints = result.keypoints  # Keypoints object for pose outputs
    probs = result.probs  # Probs object for classification outputs
    obb = result.obb  # Oriented boxes object for OBB outputs
    i += 1
    result.show()  # display to screen
    result.save(filename=f"result{i}_voith.jpg")  # save to disk