from ultralytics import YOLO

#load a model
#that was trained on OpenImagesv7, downloaded from https://docs.ultralytics.com/datasets/detect/open-images-v7/
model = YOLO("yolov8l-pretrained-oiv7.pt")

#select some photos from the validtion result where there is a fish, then we can run inference on those images
# Run batched inference on a list of images to see if pre-trained model picks up fish
# NEW USERS: you will have to customize the file paths in relation to where this python file is saved
results = model(["../scripts/data/train_files/WellsDam/images/WellsDam_1_East_20170627_13_0-30_fm_88.png",
                "../scripts/data/val_for_pretrained/wells/val/images/WellsDam_1_East_20170627_13_750-780_fm_432.png",
                "../scripts/data/val_for_pretrained/wells/val/images/WellsDam_1_East_20170627_13_750-780_fm_422.png",
                "../scripts/data/val_for_pretrained/wells/val/images/WellsDam_1_East_20170627_13_750-780_fm_112.png",
                "../scripts/data/val_for_pretrained/wells/val/images/WellsDam_1_East_20170627_13_750-780_fm_131.png",
                "../scripts/data/val_for_pretrained/wells/val/images/WellsDam_1_East_20170627_13_750-780_fm_259.png",
                "../scripts/data/train_files/WellsDam/images/WellsDam_1_East_20170627_13_0-30_fm_102.png"], conf = 0.10, iou= 0.6)  # return a list of Results objects


i = 0
# Process results list
for result in results:
    boxes = result.boxes  # Boxes object for bounding box outputs
    masks = result.masks  # Masks object for segmentation masks outputs
    keypoints = result.keypoints  # Keypoints object for pose outputs
    probs = result.probs  # Probs object for classification outputs
    obb = result.obb  # Oriented boxes object for OBB outputs
    i += 1
    result.show()  # display to screen
    result.save(filename=f"result{i}_wellsdam.jpg")  # save to disk